All Activity
- Today
-
Tharwat started following Change the color of the dimensional text
-
Change the color of the dimensional text
Tharwat replied to Nikon's topic in AutoLISP, Visual LISP & DCL
Then where did you get the codes from ? -
Change the color of the dimensional text
Nikon replied to Nikon's topic in AutoLISP, Visual LISP & DCL
Yes, I have such intentions - change the color of DIMENSION texts whose sizes have been changed after they were created.. -
Change the color of the dimensional text
GLAVCVS replied to Nikon's topic in AutoLISP, Visual LISP & DCL
Then I'm afraid I misunderstood. I thought you wanted to change the color of DIMENSION texts whose sizes have been changed after they were created. Did I misunderstand then? -
Change the color of the dimensional text
Nikon replied to Nikon's topic in AutoLISP, Visual LISP & DCL
Why are you talking about the height of the text, I'm interested in the color. Sometimes there are dimensions in the drawings, the text of which has been changed, in order to find them, I want to use a color change. -
Change the color of the dimensional text
GLAVCVS replied to Nikon's topic in AutoLISP, Visual LISP & DCL
Is this an inherited drawing or did you create it yourself? If the DIMENSION objects were created with the same height as the DIMTXT value, and your modifications were made to the text from there, it should work. -
Change the color of the dimensional text
Nikon replied to Nikon's topic in AutoLISP, Visual LISP & DCL
I do not know your code, and I did not delete anything... -
Change the color of the dimensional text
Tharwat replied to Nikon's topic in AutoLISP, Visual LISP & DCL
WHY DID YOU REMOVE MY PROGRAM'S HEADER FROM THE CODES ? REMOVE MY CODES FROM YOUR THREAD -
Change the color of the dimensional text
Nikon replied to Nikon's topic in AutoLISP, Visual LISP & DCL
thanks, but the text color hasn't changed... -
Change the color of the dimensional text
GLAVCVS replied to Nikon's topic in AutoLISP, Visual LISP & DCL
(defun C:ChDimTxtCol1 (/ int sel ent obj DimTextColor) (vl-load-com) (setq DimTextColor 1) (and (setq int -1 sel (ssget '((0 . "*DIMENSION"))) ) (while (setq int (1+ int) ent (ssname sel int)) (setq obj (vlax-ename->vla-object ent)) (if (/= (vla-get-textHeight obj) (getvar'DIMTXT)) (vla-put-TextColor obj DimTextColor)) ) ) (princ) ) -
Change the color of the dimensional text
GLAVCVS replied to Nikon's topic in AutoLISP, Visual LISP & DCL
You should simply condition the color change on the value of the 'TextHeight' property being different from '(getvar 'DIMTXT) -
Change the color of the dimensional text
Tharwat replied to Nikon's topic in AutoLISP, Visual LISP & DCL
Where did you get these codes from? -
Hello everyone! How can I change the code so that the color of the dimensional text changes only for sizes whose text has been changed manually? ; changes the color of the dimensional text by 1 (defun C:ChDimTxtCol1 (/ int sel ent obj DimTextColor) (vl-load-com) (setq DimTextColor 1) (and (setq int -1 sel (ssget '((0 . "*DIMENSION"))) ) (while (setq int (1+ int) ent (ssname sel int)) (setq obj (vlax-ename->vla-object ent)) (vla-put-TextColor obj DimTextColor) ) ) (princ) )
-
Okay I tried to modify the code with AI to base the ratio on 12 and got the following results. This line happened to be greater than 45 degrees, so the result is greater than 12 versus swapping the base of 12 from horizontal to vertical. Plus, it just gave me the results instead of providing a label to place. Here is the code it gave me. (defun C:SLOPE ( / blp pt_o pt_f frac_prec sv_osmd e_last dxf_o slope slope_h slope_v nx sv_ortho pt_start pt_x t2_slope t1_slope pt_mid pt_text pt_int ed_1 angle) ;; Turn off command echo and blip mode (setvar "cmdecho" 0) (setq blp (getvar "blipmode")) (setvar "blipmode" 0) ;; Get start point (setq pt_o (getpoint "\nSpecify the starting point: ")) (cond (pt_o ;; Get end point (setq pt_f (getpoint pt_o "\nSpecify the ending point: ")) (cond (pt_f (command "_.undo" "_group") ;; Set fraction precision (setq slope_v 12) ;; Fixed as 12-inch run for imperial standard ;; Get slope ratio (setq slope (abs (if (zerop (cadr pt_f)) 0.0 (/ (- (cadr pt_f) (cadr pt_o)) (- (car pt_f) (car pt_o))))) slope_h (fix (* slope_v slope)) nx (if (zerop slope_h) 0 (gcd slope_h slope_v)) ) ;; Simplify the ratio using GCD (while (> nx 1) (setq slope_h (/ slope_h nx) slope_v (/ slope_v nx) nx (gcd slope_h slope_v)) ) ;; Calculate angle in degrees (setq angle (atan slope)) (setq angle (* angle (/ 180.0 pi))) ;; Convert radians to degrees ;; Display slope ratio and angle (alert (strcat "Slope Ratio: " (rtos slope_h 2 0) ":" (rtos slope_v 2 0) "\nAngle: " (rtos angle 2 2) " degrees")) ;; Add other functionalities, like symbol creation and text placement, here. ) ) ) ) ;; Restore blip mode and command echo (setvar "blipmode" blp) (setvar "cmdecho" 1) (prin1) )
-
Plus, I would like the label to be dragged afterwards for placement with the line extension being adjustable. So, the label will be placed outside the line (like my image) and not centered like yours does.
-
Hi Tsuky, I tried AI to see if it can modify the code and this is what came back. I see yours doesn't include the angle, which i would like to have as well. How could the angle be added? This AutoLISP code appears to be for drawing a slope symbol and labeling it with a ratio (like 1:10). It prompts the user for a start and end point, calculates the slope, and then draws and labels it. To modify this code to work with imperial units, we need to consider what units are being used and how they are being represented. Based on the code, it seems the slope is calculated as a ratio without explicit unit measurements (like rise over run). The "Fraction accuracy" options (Unit, Dozen, Hundred) further suggest it's working with a unitless ratio. Therefore, directly converting units like meters to feet isn't applicable here. The code calculates a ratio, and that ratio remains the same regardless of the underlying units used to determine the start and end points. However, if you intend to interpret the drawn slope and its label as representing imperial units (e.g., a rise of 1 unit for every 10 units of run, where these units are now understood to be feet or inches), then the code itself doesn't need modification. The label will still be a ratio. Here's a breakdown of why direct unit conversion isn't needed and what you should consider: Slope as a Ratio: The core of the code calculates slope as the absolute ratio of the change in the Y-coordinate to the change in the X-coordinate ((/ (car dxf_o) (cadr dxf_o))). This ratio is unitless. slope_h and slope_v: These variables become the numerator and denominator of the slope ratio after being multiplied by slope_v (which is based on the "Fraction accuracy") and simplified by their greatest common divisor (GCD). These are also unitless numbers in the ratio. Labeling: The code uses rtos (real to string) to convert slope_h and slope_v into strings for the label. These strings represent the parts of the ratio. What you might need to adjust if your intention involves specific imperial units: User Interpretation: When you use this command after this point, you need to understand that the units you pick the start and end points in (e.g., feet or inches in your AutoCAD drawing) will be the basis for the slope ratio. If you pick points that are 1 foot apart horizontally and 0.1 feet apart vertically, the slope will be represented as a ratio (potentially simplified). Drawing Scale: Your AutoCAD drawing scale will determine the real-world distances represented by the units you are working in. The slope ratio will be accurate regardless of the scale, but the visual representation of the slope will be affected by it. If you did have code that explicitly dealt with measured lengths: If the original code had variables that stored lengths in metric units (e.g., length_m = 10.0), then you would need to convert those values to imperial units (e.g., length_ft = (* length_m 3.28084)). However, this specific C:SLOPE function doesn't appear to do this. In summary, to use this C:SLOPE command in an imperial drawing: Set your AutoCAD units to imperial (e.g., feet or inches). Use the SLOPE command and pick your start and end points based on your desired imperial units. The label generated will be a ratio based on the difference in the coordinates you picked, expressed as a simplified fraction (depending on the "Fraction accuracy" you choose). No direct modification of the AutoLISP code is necessary for it to be used in an imperial drawing context, as it deals with ratios, not explicit unit measurements. If you have other parts of your workflow or other code that do involve explicit metric measurements that you need to convert, please provide that code, and I can help you modify it. Sincerely, Edward Borg www.precisiondraftingllc.com https://www.facebook.com/MiscIronDetailer/ 40 Plus Years of Steel Construction Experience
-
Danielm103 started following C#, read data from an AutoCAD variable and pass it to another AutoCAD variable.
-
C#, read data from an AutoCAD variable and pass it to another AutoCAD variable.
Danielm103 replied to dilan's topic in .NET, ObjectARX & VBA
Are you trying to pass this list back to autolisp? -
Hello everyone A while ago, I had an idea that I never took seriously. But that's changed. Also, I don't know if anyone has ever had this 'idea' before: Is it possible to hide a treasure, a secret, a message, or, simply, would it be possible to hide the location of something or someone in a CAD drawing? This proposal is about that: laying out rules and parameters sufficient to find what you're looking for and a drawing in which to find it. The Universe is made up of an infinite number of equations that are constantly running to decide how to define 'reality'. In that infinite number of laws, relationships, or principles, we seem to find some that we consider 'constants'. One of them is the Fibonacci sequence, which we find repeatedly in the definition of many phenomena in the 'real' world. We've also recently seen it in this forum. Therefore, I believe it cannot be missing from the cocktail of ingredients necessary to solve any mystery worth its salt. Description: -Every living being has its own DNA, and the DNA of the objects in our drawing is stored in each of them in the form of XData. -Just as DNA is a code, the DNA of our objects is also susceptible to being LISP code. But that code, if it exists, will be 'deactivated' in each byte by the first bit, which will be set to 1. To check if it contains useful code, it will be necessary to deactivate that bit. -Only 5 objects will have useful code fragments. In the other cases, the revealed code will clearly not be LISP. -You must find a way to fit these 5 code fragments together so that it is executable, because it will give you the key to reaching the beginning of the end of the solution to the ENIGMA. -The solution to the ENIGMA will be achieved after executing an inverse Fibonacci sequence from a given point, a given number of steps to be taken, and a given direction of rotation. All of these parameters will be revealed by running the DNA code above, which will also create a function. This function must finally be run by supplying the calculated point in the inverse Fibonacci sequence as an argument. If the solution is correct, a message confirming this will be displayed. The ENIGMA will be considered discovered by whoever provides the LISP code necessary to obtain the solution. I'll TAKE a COUPLE of WEEKS to prepare the appropriate drawing for this. This way, I assume the necessary time will have passed for it to become sufficiently known. And also, I suppose, it will give some time to prepare their "weapons"
-
jim78b started following express tool 2025 - replace block not work
-
express tool 2025 - replace block not work
jim78b posted a topic in AutoCAD 2D Drafting, Object Properties & Interface
-
abilash65023997 joined the community
-
dilan started following C#, read data from an AutoCAD variable and pass it to another AutoCAD variable.
-
C#, read data from an AutoCAD variable and pass it to another AutoCAD variable.
dilan posted a topic in .NET, ObjectARX & VBA
Hi, I'm writing a function in C#. The goal is to read an XML file and extract all point numbers into a list. I can't figure out how to pass the file path for reading through an AutoCAD variable. Right now, I'm doing it via a configuration file, but that's not convenient. I want to get the file path from an AutoCAD variable—for example, my file path is stored in a variable like filepathXML. Additionally, the function currently outputs the result to the AutoCAD command line, but I need to assign this result to an AutoCAD variable (e.g., listPointID). I also can't understand how to do that. Overall, the code works and does what I need, but I'm struggling with handling the variables properly. using System; using System.Collections.Generic; using System.IO; using System.Reflection; using System.Text; using Autodesk.AutoCAD.ApplicationServices; using Autodesk.AutoCAD.Runtime; using Autodesk.AutoCAD.EditorInput; public class PointIdExtractor { [CommandMethod("GetPointIds")] public static void GetPointIdsCommand() { Document doc = Application.DocumentManager.MdiActiveDocument; Editor ed = doc.Editor; try { // Getting the path from the configuration file string filePath = GetFilePathFromConfig(); if (string.IsNullOrEmpty(filePath)) { ed.WriteMessage("\nError: Failed to get file path from configuration"); return; } if (!File.Exists(filePath)) { ed.WriteMessage($"\nError: File not found at path: {filePath}"); return; } List<int> ids = GetPointIdsFromFile(filePath); // We format the output as (1 2 3 4 5 ...) ed.WriteMessage($"\nFound point IDs: {FormatAsLispList(ids)}"); } catch (System.Exception ex) { ed.WriteMessage($"\nError: {ex.Message}"); } } private static string GetFilePathFromConfig() { try { // Path to configuration file next to DLL string configPath = Path.Combine( Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), "PointExtractor.cfg"); if (!File.Exists(configPath)) { // Create a file with an example if it does not exist File.WriteAllText(configPath, "DataXmlPath=C:\\path\\to\\your\\file.xml"); return null; } // Read all configuration lines foreach (string line in File.ReadAllLines(configPath)) { if (line.StartsWith("DataXmlPath=")) { return line.Substring("DataXmlPath=".Length).Trim(); } } return null; } catch { return null; } } private static string FormatAsLispList(List<int> numbers) { StringBuilder sb = new StringBuilder("("); bool first = true; foreach (int num in numbers) { if (!first) sb.Append(" "); sb.Append(num); first = false; } sb.Append(")"); return sb.ToString(); } public static List<int> GetPointIdsFromFile(string filePath) { List<int> ids = new List<int>(); const string searchPattern = "<P id=\""; try { using (StreamReader reader = new StreamReader(filePath, Encoding.UTF8)) { string line; while ((line = reader.ReadLine()) != null) { int pos = 0; while ((pos = line.IndexOf(searchPattern, pos, StringComparison.Ordinal)) != -1) { int start = pos + searchPattern.Length; int end = line.IndexOf('"', start); if (end > start) { string numStr = line.Substring(start, end - start); if (int.TryParse(numStr, out int num)) { ids.Add(num); } } pos = end > 0 ? end : pos + 1; } } } return ids; } catch (System.Exception ex) { throw new System.Exception($"Failed to process file {filePath}: {ex.Message}"); } } } -
Selecting Dynamic Blocks and Activating Action Parameters.
troggarf replied to DavidP's topic in AutoLISP, Visual LISP & DCL
I selected both dumb blocks and dynamic blocks at all of the clickable points. I still don't understand what you speak of by saying "similar to Shift+left click on block grips?". I was curious that I missed out on something, but didn't see anything... Do you have a loaded tool that lets you Shift + left click on a grip that does something that the rest of us don't have? - Yesterday
-
Oops sorry, I was writing my post...
-
I have this for a metric system, I don't know if it would be suitable for a foot system...! But it can be a start for you. (defun C:SLOPE ( / blp pt_o pt_f frac_prec sv_osmd e_last dxf_o slope slope_h slope_v nx sv_ortho pt_start pt_x t2_slope t1_slope pt_mid pt_text pt_int ed_1) (setvar "cmdecho" 0) (setq blp (getvar "blipmode")) (setvar "blipmode" 0) (initget 9) (setq pt_o (getpoint "\nSpecify the starting point: ")) (cond (pt_o (initget 41) (setq pt_f (getpoint pt_o "\nChoosing the end point: ")) (cond (pt_f (command "_.undo" "_group") (cond ((and (not (eq (getvar "USERI1") 1)) (not (eq (getvar "USERI1") 10)) (not (eq (getvar "USERI1") 100))) (initget "Unit Dozen Hundred") (setq frac_prec (getkword "\nFraction accuracy [Unit/Dozen/Hundred]<Dozen>: ")) (if (not frac_prec) (setq frac_prec "Dozen")) (cond ((eq frac_prec "Unit") (setq slope_v 1)) ((eq frac_prec "Dozen") (setq slope_v 10)) ((eq frac_prec "Hundred") (setq slope_v 100)) ) (setvar "USERI1" slope_v) ) (T (setq slope_v (getvar "USERI1"))) ) (setq sv_osmd (getvar "osmode")) (setvar "osmode" 0) (command "_.ray" pt_o pt_f "") (setq e_last (entlast) dxf_o (trans (cdr (assoc 11 (entget e_last))) 0 1 T) ) (entdel e_last) (setq slope (abs (if (zerop (cadr dxf_o)) 0.0 (/ (car dxf_o) (cadr dxf_o)))) slope_h (fix (* slope_v slope)) nx (if (zerop slope_h) 0 (gcd slope_h slope_v)) sv_ortho (getvar "orthomode") ) (while (> nx 1) (setq slope_h (/ slope_h nx) slope_v (/ slope_v nx) nx (gcd slope_h slope_v)) ) (setvar "orthomode" 1) (setq pt_start (mapcar '/ (mapcar '+ pt_o pt_f) '(2.0 2.0 2.0)) pt_start (list (car pt_start) (cadr pt_start) 0.0)) (initget 9) (setq pt_x (getpoint pt_start "\nSpecify the size of the symbol: ") pt_x (list (car pt_x) (cadr pt_x))) (if (equal (car pt_x) (car pt_start) 1E-12) (setq t2_slope (rtos slope_h 2 0) t1_slope (rtos slope_v 2 0)) (setq t2_slope (rtos slope_v 2 0) t1_slope (rtos slope_h 2 0)) ) (repeat 2 (command "_.dimordinate" pt_start "_text" t1_slope pt_x) (setq pt_mid (mapcar '/ (mapcar '+ pt_start pt_x) '(2.0 2.0 2.0))) (if (equal (car pt_x) (car pt_start) 1E-12) (setq pt_int (polar pt_x 0.0 (distance pt_start pt_x))) (setq pt_int (polar pt_x (/ pi 2.0) (distance pt_start pt_x))) ) (setq pt_start (inters pt_o pt_f pt_x pt_int nil) t1_slope t2_slope ) (if (null pt_start) (setq pt_start pt_x)) (setq pt_text (polar pt_mid (angle pt_start pt_x) (getvar "dimtxt")) ) (command "_aidimtextmove" "_2" (entlast) "" pt_text) (if (not ed_1) (setq ed_1 (entlast))) ) (command "_.-group" "_create" "*" "" (entlast) ed_1 "") (setvar "orthomode" sv_ortho) (setvar "osmode" sv_osmd) (command "_.undo" "_end") ) ) ) ) (setvar "blipmode" blp) (setvar "cmdecho" 1) (prin1) )
-
A good task to start learning lisp. Select a line (entsel Get X & Y of start and end points, work out X & Y, work out X rescaled to Y = 12 (entget (car (entsel Ask for a point or hard code a distance away use (polar pt ang dist)& (getpoint Draw the 3 lines (command "line" Draw the text. (command "text" Its not very hard so I would ask others to not post code, at some point learning how to do a simple lisp task is well worth while. So have a go plenty here can help when you get stuck.
-
Export the surface from Civil 3D to an .xml file using LISP
BIGAL replied to dilan's topic in AutoLISP, Visual LISP & DCL
This is similar but allows you to pick a surface and return its name, the vercheck does same as your get registry just a different variable name. (ah:vercheck) ; version check see vercheck.lsp (if (not AT:ListSelect)(load "Listseelct")) (vlax-for j (vlax-get *AeccDoc* 'SurfaceS) (setq lst (cons (cons (vla-get-name j) j) lst)) ) ;if length of surfaces more than 1 else skip pick if 0 then msg and exit (setq lenlst (length lst)) (if (= lenlst 0) (progn (Getstring "\nYou have no surfaces press any key to exit") (exit) ) ) (if (= lenlst 1) (setq surfacepick (car (nth 0 lst))) ; pull surface out of dotted pair ) (if (> lenlst 1) (progn (setq surfacepick (car (AT:ListSelect "Set new surface " "Select surface name" 10 10 "false" (vl-sort (mapcar (function car) lst) '<) ))) ) ; end progn ) ;end if (setq lst2 lst) ; make answer returned list2 listselect.lsp -
Cadkiller started following Bevel (slope) Label
-
Hello Group, It's been a long time since I posted anything on this forum. I searched for this topic but didn't find anything to help me create it. I'm trying to create a bevel symbol which will give the sloped/pitch info for a selected line. Based off of 12" run and give the angle as well. Any help would be greatly appreciated. Sincerely, Edward Borg www.precisiondraftingllc.com https://www.facebook.com/MiscIronDetailer/ 40 Plus Years of Steel Construction Experience